; ado.asm: ad 10F322-vel. A 10F32x mindent egy lapra
; tesz fel, 40-nl kezddik a felhasznli RAM.
; 5/15/45 us, a 2,5/7,5/22,5 megtoldsval.
; Most mg van freki kimenete.
; Resettel, extra alacsony kszbbel

	list p=10f320
	list r=dec
	#include <p10f320.inc>
	#include <prlx.inc>
	
	__config	24c6h	
	
	cblock 40h
	flags
	count
	ct0
	count1
	resh
	resl
	endc
	
#define	all	flags,0
#define out	porta,2
#define	open	porta,0
#define adgo	adcon,go_not_done
limit	equ	0ffh
	
	org	0
	goto	start
; a fprogram elszr inicializl	
start
	clrf	porta
	movlw	70h
	movwf	osccon
	movlw	8
	movwf	option_reg
	movlw	9
	movwf	trisa
	movwf	wpua
	clrf	ansela
	movlw	82h
	movwf	fvrcon	; bekap, 2,048 V
	movlw	0bdh
	movwf	adcon	; refet mrhet
	#include <clc1.inc> ; flfrekvencis kimenet
	clrf	flags
	call	kezd	; kezdeti ksleltets
	clrf	resh	; nehogy mrs nlkl kiakadjon
	clrf	resl
main
	sb	all	; de all= 0!
	bsf	out	; LED bekap
	sb	open	; els bemenetvizsglat (duplnak szmt)
	goto	common
	call	dum
	call	dum+1
common
	snb	open	; tovbbi bemenetvizsglatok (szimplk)
	call	dum
	snb	open
	call	dum
	snb	open
	call	dum	; 2,25 us vge	
;-----------------------------------------------
	snb	open
	call	dum
	snb	open
	call	dum
	snb	open
	call	dum
	snb	open
	call	dum
	snb	open
	call	dum	; 4,75 us vge
;------------------------------------------------
	bcf	out	; +0,25 us, LED lelltva
; itt kezddik a 45 us pihen (-3 tem, mert ugrik s nyit)
	bsf	adgo	; A/D konverzi indul
	decfsz	count1,f
	goto	collect
	rrf	resh,f	; ez az elz 8 kr sszege
	rrf	resl,f
	rrf	resh,f
	rrf	resl,f
	rrf	resh,f
	rrf	resl,f	 ; most mr az tlaga
	cjal	resl,limit,leall
	call	dum+1
	movlw	8
	movwf	count1
	clrf	resh
	clrf	resl
	goto	pad
collect
	call	dum
	call	dum
	call	dum
pad
	nop
	nop
	call	dly27
	movf	adres,w	; mostanra befejezte az A/D
	addwf	resl,f
	snc
	incf	resh,f
	call	dly33
;---------------------------------------------------
	call	w10	;10us
	call	w10	;10 us
	call	dum	;1,25 us
	call	dum	;1,25 us
;----------------------------------------------------
	goto	main

; ksleltet szubrutinok
kezd
	movlw	100
	movwf	ct0
cyc0
	call	long
	decfsz	ct0,f
	goto	cyc0
	return	
long
	movlw	120
	movwf	count
	goto	cyc	
w10	; hvssal egytt 10 us
	movlw	11
	nop
load
	movwf	count
cyc
	decfsz	count,f
	goto	cyc
	nop		; ez j az elz helyett
	return
dly27
	movlw	6
	goto	load
dly33	movlw	9
	goto	load	
; s van ez a szubrutin, hvssal egytt 5 ciklus, ms dolga nincs:
dum
	nop
	return
	
leall
;	goto	main
	bsf	all
	clrf	adcon
	clrf	fvrcon
	sleep
	nop
	goto	$-2	
	
	end